## Script (Python) "getCalCPSDayViewParams"
##parameters=context_url,datestring,location,event_types
# $Id: getCalCPSDayViewParams.py,v 1.2 2003/10/16 14:11:02 epietrig Exp $
"""Compute the correct list of URL parameters for calendar_cpsday_view"""

from urllib import urlencode

args = {'date': datestring}

if location and not location.isspace():
    args['location'] = location

if event_types:
    args['event_types'] = ','.join(event_types)

return context_url + '/calendar_cpsday_view?' + urlencode(args)
